commit 11f447b943718a35bb327d7884b03c1d9d6afc22
Author: Vojtěch Bartička <aitakaitov@gmail.com>
Date:   Sat Apr 9 21:44:23 2022 +0200

    Code cleanup

diff --git a/Backend/Backend/Controllers/DocumentController.cs b/Backend/Backend/Controllers/DocumentController.cs
index b2a4f2d..6a465f5 100644
--- a/Backend/Backend/Controllers/DocumentController.cs
+++ b/Backend/Backend/Controllers/DocumentController.cs
@@ -65,12 +65,12 @@ public class DocumentController : Common.CommonControllerBase
         {
             documentService.AddDocuments(documentAddRequest, clientInfo.LoggedUser.Id);
         }
-        catch (InvalidOperationException ex)
+        catch (InvalidOperationException)
         {
             logger.Warning($"Error in DocumentService.AddDocuments - could not retrieve user with GUID {clientInfo.LoggedUser.Id} from database");
             throw new InternalErrorException();
         }
-        catch (Exception ex)
+        catch (Exception)
         {
             logger.Warning($"Error in DocumentService.AddDocuments - could not process ZIP file");
             throw new BadRequestException("Invalid ZIP file");
diff --git a/Backend/Core/Entities/Document.cs b/Backend/Core/Entities/Document.cs
index 3b5cb32..c714765 100644
--- a/Backend/Core/Entities/Document.cs
+++ b/Backend/Core/Entities/Document.cs
@@ -8,6 +8,7 @@ using System.Threading.Tasks;
 
 namespace Core.Entities
 {
+#nullable disable
     public class Document : BaseEntity
     {
         public string Name { get; set; }
diff --git a/Backend/Core/Entities/TagCategory.cs b/Backend/Core/Entities/TagCategory.cs
index 215ee2f..4b9a574 100644
--- a/Backend/Core/Entities/TagCategory.cs
+++ b/Backend/Core/Entities/TagCategory.cs
@@ -7,6 +7,7 @@ using System.Threading.Tasks;
 
 namespace Core.Entities
 {
+#nullable disable
     public class TagCategory : BaseEntity
     {
         public string Name { get; set; }
diff --git a/Backend/Core/Entities/User.cs b/Backend/Core/Entities/User.cs
index 96422d8..3ef23e3 100644
--- a/Backend/Core/Entities/User.cs
+++ b/Backend/Core/Entities/User.cs
@@ -9,6 +9,7 @@ using Core.Enums;
 
 namespace Core.Entities
 {
+#nullable disable
     public class User : BaseEntity
     {
         public string Username { get; set; }
diff --git a/Backend/Models/Authentication/LoginResponse.cs b/Backend/Models/Authentication/LoginResponse.cs
index 8441bd4..4fe0068 100644
--- a/Backend/Models/Authentication/LoginResponse.cs
+++ b/Backend/Models/Authentication/LoginResponse.cs
@@ -13,6 +13,7 @@ public class LoginResponse
     {
     }
 
+#nullable disable
     public bool Ok { get; set; }
     public string Token { get; set; }
     public DateTime Expiration { get; set; }
diff --git a/Backend/Models/Documents/DocumentAddInfo.cs b/Backend/Models/Documents/DocumentAddInfo.cs
index 9db599c..771b59b 100644
--- a/Backend/Models/Documents/DocumentAddInfo.cs
+++ b/Backend/Models/Documents/DocumentAddInfo.cs
@@ -7,6 +7,7 @@ using System.Threading.Tasks;
 
 namespace Models.Documents;
 
+# nullable disable
 /**
  * If the file is plaintext, we except it to be a single document
  * If the file is base64, we expect it to be a ZIP file with plaintext documents in its root
diff --git a/Backend/Models/Documents/DocumentAddRequest.cs b/Backend/Models/Documents/DocumentAddRequest.cs
index 8622386..74a55c3 100644
--- a/Backend/Models/Documents/DocumentAddRequest.cs
+++ b/Backend/Models/Documents/DocumentAddRequest.cs
@@ -6,6 +6,7 @@ using System.Threading.Tasks;
 
 namespace Models.Documents;
 
+# nullable disable
 public class DocumentAddRequest
 {
     public List<DocumentAddInfo> Documents { get; set; } 
diff --git a/Backend/Models/Documents/DocumentListInfo.cs b/Backend/Models/Documents/DocumentListInfo.cs
index 848acfb..3f1ba24 100644
--- a/Backend/Models/Documents/DocumentListInfo.cs
+++ b/Backend/Models/Documents/DocumentListInfo.cs
@@ -7,6 +7,7 @@ using System.Threading.Tasks;
 
 namespace Models.Documents;
 
+# nullable disable
 public class DocumentListInfo
 {
     public Guid Id { get; set; }
diff --git a/Backend/Models/Users/UserInfo.cs b/Backend/Models/Users/UserInfo.cs
index 024f19b..23081f4 100644
--- a/Backend/Models/Users/UserInfo.cs
+++ b/Backend/Models/Users/UserInfo.cs
@@ -6,6 +6,7 @@ using System.Threading.Tasks;
 
 namespace Models.Users
 {
+# nullable disable
     public class UserInfo
     {
         public Guid Id { get; set; }