commit 1200e6ed7b8a854a98e62f1e619204c89a1dce20
Author: Vojtěch Bartička <aitakaitov@gmail.com>
Date:   Sun Apr 10 11:35:57 2022 +0200

    Moved Enums to Models project

diff --git a/Backend/Backend/Controllers/DocumentController.cs b/Backend/Backend/Controllers/DocumentController.cs
index 6a465f5..64a731b 100644
--- a/Backend/Backend/Controllers/DocumentController.cs
+++ b/Backend/Backend/Controllers/DocumentController.cs
@@ -35,7 +35,7 @@ public class DocumentController : Common.CommonControllerBase
             return Problem();
         }
 
-        if (clientInfo.LoggedUser.Role != Core.Enums.ERole.ADMINISTRATOR)
+        if (clientInfo.LoggedUser.Role != Models.Enums.ERole.ADMINISTRATOR)
         {
             return Forbid("User is not administrator");
         }
@@ -56,7 +56,7 @@ public class DocumentController : Common.CommonControllerBase
             return Problem();
         }
 
-        if (clientInfo.LoggedUser.Role != Core.Enums.ERole.ADMINISTRATOR)
+        if (clientInfo.LoggedUser.Role != Models.Enums.ERole.ADMINISTRATOR)
         {
             return Forbid("User is not administrator");
         }
diff --git a/Backend/Core/Entities/Annotation.cs b/Backend/Core/Entities/Annotation.cs
index 88867ac..2128354 100644
--- a/Backend/Core/Entities/Annotation.cs
+++ b/Backend/Core/Entities/Annotation.cs
@@ -1,4 +1,4 @@
-﻿using Core.Enums;
+﻿using Models.Enums;
 using System;
 using System.Collections.Generic;
 using System.ComponentModel.DataAnnotations;
diff --git a/Backend/Core/Entities/User.cs b/Backend/Core/Entities/User.cs
index 3ef23e3..4e60155 100644
--- a/Backend/Core/Entities/User.cs
+++ b/Backend/Core/Entities/User.cs
@@ -5,7 +5,7 @@ using System.Linq;
 using System.Text;
 using System.Text.Json.Serialization;
 using System.Threading.Tasks;
-using Core.Enums;
+using Models.Enums;
 
 namespace Core.Entities
 {
diff --git a/Backend/Core/Enums/ERole.cs b/Backend/Core/Enums/ERole.cs
deleted file mode 100644
index 2a5d70d..0000000
--- a/Backend/Core/Enums/ERole.cs
+++ /dev/null
@@ -1,14 +0,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
-
-namespace Core.Enums
-{
-    public enum ERole : int
-    {
-        ANNOTATOR = 0,
-        ADMINISTRATOR = 1
-    }
-}
diff --git a/Backend/Core/Enums/EState.cs b/Backend/Core/Enums/EState.cs
deleted file mode 100644
index 61977e5..0000000
--- a/Backend/Core/Enums/EState.cs
+++ /dev/null
@@ -1,15 +0,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
-
-namespace Core.Enums
-{
-    public enum EState
-    {
-        DONE, 
-        IN_PROGRESS,
-        NEW
-    }
-}
diff --git a/Backend/Core/Seeding/Seeder.cs b/Backend/Core/Seeding/Seeder.cs
index d6fb105..1b1e954 100644
--- a/Backend/Core/Seeding/Seeder.cs
+++ b/Backend/Core/Seeding/Seeder.cs
@@ -1,6 +1,6 @@
 ﻿using Core.Contexts;
 using Core.Entities;
-using Core.Enums;
+using Models.Enums;
 using Microsoft.EntityFrameworkCore;
 using System;
 using System.Collections.Generic;
diff --git a/Backend/Core/Services/UserService/IUserService.cs b/Backend/Core/Services/UserService/IUserService.cs
index 7bacc6d..96b3457 100644
--- a/Backend/Core/Services/UserService/IUserService.cs
+++ b/Backend/Core/Services/UserService/IUserService.cs
@@ -1,5 +1,5 @@
 ﻿using Core.Entities;
-using Core.Enums;
+using Models.Enums;
 using System;
 using System.Collections.Generic;
 using System.Linq;
diff --git a/Backend/Core/Services/UserService/UserServiceEF.cs b/Backend/Core/Services/UserService/UserServiceEF.cs
index 35103dc..c3ca409 100644
--- a/Backend/Core/Services/UserService/UserServiceEF.cs
+++ b/Backend/Core/Services/UserService/UserServiceEF.cs
@@ -1,6 +1,6 @@
 ﻿using Core.Contexts;
 using Core.Entities;
-using Core.Enums;
+using Models.Enums;
 using System;
 using System.Collections.Generic;
 using System.Linq;
diff --git a/Backend/Models/Authentication/LoginResponse.cs b/Backend/Models/Authentication/LoginResponse.cs
index 4fe0068..5ce4aab 100644
--- a/Backend/Models/Authentication/LoginResponse.cs
+++ b/Backend/Models/Authentication/LoginResponse.cs
@@ -1,3 +1,5 @@
+using Models.Enums;
+
 namespace Models.Authentication;
 
 public class LoginResponse
@@ -17,4 +19,5 @@ public class LoginResponse
     public bool Ok { get; set; }
     public string Token { get; set; }
     public DateTime Expiration { get; set; }
+    public ERole Role { get; set; }
 }
\ No newline at end of file
diff --git a/Backend/Models/Enums/ERole.cs b/Backend/Models/Enums/ERole.cs
new file mode 100644
index 0000000..ea130a0
--- /dev/null
+++ b/Backend/Models/Enums/ERole.cs
@@ -0,0 +1,14 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace Models.Enums
+{
+    public enum ERole : int
+    {
+        ANNOTATOR = 0,
+        ADMINISTRATOR = 1
+    }
+}
diff --git a/Backend/Models/Enums/EState.cs b/Backend/Models/Enums/EState.cs
new file mode 100644
index 0000000..69ab18a
--- /dev/null
+++ b/Backend/Models/Enums/EState.cs
@@ -0,0 +1,15 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace Models.Enums
+{
+    public enum EState
+    {
+        DONE, 
+        IN_PROGRESS,
+        NEW
+    }
+}